// # 1 "bivfact.mtx"
// $Header$
// # 1 "header.h" 1
/*
///////////////////////////////////////////////////

   Kronecker Package version 0.166-9 for Magma

///////////////////////////////////////////////////

Date: sam jun  8 14:57:48 UTC 2002
Copyright (C) 1999--2002, G. Lecerf, Centre National de la Recherche Scientifique
Location: 
          Laboratoire de mathmatiques, LAMA - UMR 8100
          Universit de Versailles St-Quentin-en-Yvelines
          45 avenue des Etats-Unis - Btiment Fermat
          78035 Versailles, France
Url: http://kronecker.medicis.polytechnique.fr/
Bug report to: Gregoire.Lecerf@math.uvsq.fr

!!! WARNING, this package comes with NO WARRANTY !!!
*/

// # 3 "bivfact.mtx" 2
// $Log$

/* Bivariate polynomial factorization module
 *
 * GL, April 2002.
 */
 
intrinsic BivariateFactorization(p) -> SeqEnum, RngElt
{
  Factorization of f into irreducible factors together
  with the appropriate unit.
}
  UP<T>:=Parent(p);
  LS<t>:=BaseRing(UP);
  F:=BaseRing(LS);
  dT:=Degree(p);
  //dt:=Max([Degree(z) : z in Coefficients(p)]);
  dt:=dT;
  dt:=20;
  h:=hom<LS->F | x:->Evaluate(x,0)>;
  UP0<T>:=PolynomialRing(F);
  P:=UP0![h(Coefficient(p,i)) : i in [0..Degree(p)]];
  fact:=Factorization(P);
P;
  fact:=[ UP!z[1] : z in fact];
fact;
  sigma:=1;
  pp:=Derivative(p);
  N:=#fact;
  while sigma le 2*dt+1 do
    sigma*:=2;
    tmp1:=SimultaneousModulo(p,fact);
    "tmp1"; tmp1;
    Universe(tmp1);
    tmp2:=SimultaneousModulo(pp,fact);
    "tmp2";tmp2;
    A:=[quo<UP|z> : z in fact];
    fact:=[ fact[i]+UP!(A[i]!Derivative(fact[i])*A[i]!tmp1[i]*(A[i]!tmp2[i]^(-1))) : i in [1..N]];
  end while;
  traces:=[ Coefficient(z,Degree(z)-1) : z in fact];
  "traces";traces;
  s,d:=PadeHermite_BeLa_superfast(traces,20,[0 : i in [1..N]]);
  s,d;
  return traces,1;
end intrinsic;
