// # 1 "hack.mtx"
// $Header$
// # 1 "header.h" 1
/*
///////////////////////////////////////////////////

   Kronecker Package version 0.166-9 for Magma

///////////////////////////////////////////////////

Date: sam jun  8 14:57:48 UTC 2002
Copyright (C) 1999--2002, G. Lecerf, Centre National de la Recherche Scientifique
Location: 
          Laboratoire de mathmatiques, LAMA - UMR 8100
          Universit de Versailles St-Quentin-en-Yvelines
          45 avenue des Etats-Unis - Btiment Fermat
          78035 Versailles, France
Url: http://kronecker.medicis.polytechnique.fr/
Bug report to: Gregoire.Lecerf@math.uvsq.fr

!!! WARNING, this package comes with NO WARRANTY !!!
*/

// # 3 "hack.mtx" 2
// $Log$
// # 1 "macros.h" 1
// $Header$
// $Log$


















declare verbose BbpVerbose,5;
GlobalBbpVerbose:=[0,0,0,0,0,5];
declare verbose FdaVerbose,5;
GlobalFdaVerboseVerbose:=[0,0,0,1,2,3];
declare verbose FiberVerbose,5;
GlobalFiberVerbose:=[0,1,2,3,4,5];
declare verbose GeometricSolveVerbose,5;
GlobalGeometricSolveVerbose:=[0,1,2,3,4,5];
declare verbose HenselVerbose,5;
GlobalHenselVerboseVerbose:=[0,1,2,3,3,4];
declare verbose IntersectionVerbose,5;
GlobalIntersectionVerbose:=[0,1,2,2,3,4];
declare verbose NonUniversalVerbose,5;
GlobalNonUniversalVerbose:=[0,1,2,3,4,5];
declare verbose AlgebraicApproximantVerbose,5;
GlobalAlgebraicApproximantVerbose:=[0,0,0,1,2,3,5];




















// MathML support

declare verbose KroneckerMathMLVerbose,5;









// # 5 "hack.mtx" 2

intrinsic ChangePrecision(R::RngSerLaur,n) -> .,.
{}
  h:=map<R->R | x:-> Truncate(x) + O((R.1)^n) >;
  R`Precision:=n;
  return R,h;
end intrinsic;

/* faster p-adic integers... */

intrinsic pAdicIntegers(p,n) -> .
{
  Return Integers(p) with attributes Prime and Precision. n must be prime.
}
  AddAttribute(RngIntRes,"Prime");
  AddAttribute(RngIntRes,"Precision");
  R:=Integers(p^n);
  R`Prime:=p;
  R`Precision:=n;
  return(R);

end intrinsic;

intrinsic BaseRing(R::RngIntRes) -> .
{}
  return GF(R`Prime);
end intrinsic;

intrinsic ChangePrecision(R::RngIntRes,n) -> .,.
{}
  oldprecision:=R`Precision;
  N:=pAdicIntegers(R`Prime,n);
  h:=Bang(R,N);
  return N,h;
end intrinsic;

intrinsic Precision(R::RngIntRes) -> .
{}
  return R`Precision;
end intrinsic;

// Should be fixed in 2.9 >> TODO
intrinsic MyChangeRing(X::Mtrx,S) -> Mtrx
{
  Fixes the vector type problem.
}
  r:=NumberOfRows(X);
  c:=NumberOfColumns(X);
  if ISA(Type(X), ModTupRngElt) then
    return Vector(S,c,ChangeUniverse(Eltseq(X),S));
  end if;
  return Matrix(S,r,c,ChangeUniverse(Eltseq(X),S));
end intrinsic;

intrinsic MyChangeRing(~X::Mtrx,S::Rng)
{
}
  X:=MyChangeRing(X,S);
end intrinsic;

intrinsic MyChangeRing(X::Mtrx,S::Rng,f) -> Mtrx
{
  Given a matrix M over a ring R, together with a ring S,
  and a map f: R -> S, return the matrix over S obtained
  from X obtained by mapping the elements of X into S via f.
}
  r:=NumberOfRows(X);
  c:=NumberOfColumns(X);
  if ISA(Type(X), ModTupRngElt) then
    return Vector(S,c,ChangeUniverse(Eltseq(X),S,f));
  end if;
  return Matrix(S,r,c,ChangeUniverse(Eltseq(X),S,f));
end intrinsic;

intrinsic MyChangeRing(~X::Mtrx,S::Rng,f)
{
}
  X:=MyChangeRing(X,S,f);
end intrinsic;

// f is a user programm or whatever
// include into Magma? >> TODO
intrinsic ChangeUniverse(~s::SeqEnum,E::Str,f)
{
}
  s:=[E| f(z): z in s];
end intrinsic;

intrinsic ChangeUniverse(s::SeqEnum,E::Str,f)-> SeqEnum
{
}
  return([E| f(z): z in s]);
end intrinsic;

// recursive precision settings, should not be exported... >> TODO
// For Upol et quo de Upol... -> dans hensel_base?
intrinsic ChangePrecision(A::RngUPolRes,n) -> .,.
{}
  UP<T>:=PreimageRing(A);
  q:= Modulus(A);
  UP2<T>,h:=ChangePrecision(UP,n);
  q2:=h(q);
  B:=quo<UP2|q2>;
  f:=function(x)
    A:=Parent(x);
    UP<T>:=PreimageRing(A);
    return B!h(UP!x);
  end function;
  return B,f;
end intrinsic;

intrinsic ChangePrecision(R,n) -> .,.
{}
  A:=BaseRing(R);
  B,h:=ChangePrecision(A,n);
  if Type(R) eq AlgMat then
    return ChangeRing(R,B,h);
  else
    return ChangeRing(R,B,h);
  end if;
end intrinsic;

/* Hack that seems to be used in hensel_fda */
intrinsic 'eq'(x::Rec,y::Rec) -> BoolElt
{
}
  for f in Names(x) do
    if x``f ne y``f then return false; end if;
  end for;
  return true;
end intrinsic;

intrinsic ChangeRing(p::RngMPolElt,R::Rng,f) -> RngMPolElt
{
}
  MP:=Parent(p);
  n:=Rank(MP);
  MPout:=PolynomialAlgebra(R,n);
  m:=Monomials(p);
  c:=Coefficients(p);
  return &+[MPout| f(c[i])*&*[MPout| (MPout.j)^Degree(m[i],j)
    : j in [1..n]] : i in [1..#m]];
end intrinsic;

intrinsic ChangeRing(~s::RngMPolElt,R::Rng,f)
{
}
  s:=ChangeRing(s,R,f);
end intrinsic;

intrinsic ChangeRing(p::RngMPolElt,R::Rng) -> RngMPolElt
{
}
  MP:=Parent(p);
  n:=Rank(MP);
  MPout:=PolynomialAlgebra(R,n);
  m:=Monomials(p);
  c:=Coefficients(p);
  return &+[MPout| (R!c[i])*&*[MPout| (MPout.j)^Degree(m[i],j)
    : j in [1..n]] : i in [1..#m]];
end intrinsic;

intrinsic ChangeRing(~s::RngMPolElt,R::Rng)
{
}
  s:=ChangeRing(s,R);
end intrinsic;
