// # 1 "hensel_fda.mtx"
// $Header$
// # 1 "header.h" 1
/*
///////////////////////////////////////////////////

   Kronecker Package version 0.166-9 for Magma

///////////////////////////////////////////////////

Date: lun jun 10 17:09:21 UTC 2002
Copyright (C) 1999--2002, G. Lecerf, Centre National de la Recherche Scientifique
Location: 
          Laboratoire de mathmatiques, LAMA - UMR 8100
          Universit de Versailles St-Quentin-en-Yvelines
          45 avenue des Etats-Unis - Btiment Fermat
          78035 Versailles, France
Url: http://kronecker.medicis.polytechnique.fr/
Bug report to: Gregoire.Lecerf@math.uvsq.fr

!!! WARNING, this package comes with NO WARRANTY !!!
*/

// # 3 "hensel_fda.mtx" 2
// $Log$

// # 1 "macros.h" 1
// $Header$
// $Log$


















declare verbose BbpVerbose,5;
GlobalBbpVerbose:=[0,0,0,0,0,5];
declare verbose FdaVerbose,5;
GlobalFdaVerboseVerbose:=[0,0,0,1,2,3];
declare verbose FiberVerbose,5;
GlobalFiberVerbose:=[0,1,2,3,4,5];
declare verbose GeometricSolveVerbose,5;
GlobalGeometricSolveVerbose:=[0,1,2,3,4,5];
declare verbose HenselVerbose,5;
GlobalHenselVerboseVerbose:=[0,1,2,3,3,4];
declare verbose IntersectionVerbose,5;
GlobalIntersectionVerbose:=[0,1,2,2,3,4];
declare verbose NonUniversalVerbose,5;
GlobalNonUniversalVerbose:=[0,1,2,3,4,5];
declare verbose AlgebraicApproximantVerbose,5;
GlobalAlgebraicApproximantVerbose:=[0,0,0,1,2,3,5];




















// MathML support

declare verbose KroneckerMathMLVerbose,5;









// # 6 "hensel_fda.mtx" 2

import "hensel_base.m": hensel_base__FromSeriesToRationalCoefficients, hensel_base__FromSeriesToRationalCoefficients_Pade, hensel_base__EvaluateAtOne, hensel_base__MultiplyByCommonDenominator, hensel_base__StopCriterion_Bound, hensel_base__StopCriterion_Integers, hensel_base__HeuristicCombineFactorized;// #import hensel_base.m
import "random.m": random_RandomInvertibleMatrix, random_RandomInvertibleUpperTriangularMatrix, random_RandomVector, random_RandomPrimeNumber, random_RandomSequence;// #import random.m

/*
 * Module: Hensel Lifting for multiple components
 * Implementation of the global Newton lifting operator via the
 * Fast Deflation Algorithme (FDA).
 */

/****************************************************************************
                           Lifting Core
*****************************************************************************/
/*
  Most of the lifting core is actually contained in fda.mtx.
*/

debug:=procedure(ls)
  A<a>:=MpsBaseRing(Universe(ls`NestedCoordinates));
  UP<T>:=PreimageRing(A);
  q:=Modulus(A);
  point:= ChangeUniverse(ls`MagicPoint,A)
    cat [A| MpsConstantCoefficient(z) : z in ls`NestedCoordinates];
  du:=(T-UP!Evaluate(ls`PrimitiveElement, point)) mod q;
end procedure;

GlobalizeSolution:=procedure(~ls)
/*
*/
  A<a>:=MpsBaseRing(Universe(ls`NestedCoordinates));
  UP<T>:=PreimageRing(A);
  q:=Modulus(A);
  point:= ChangeUniverse(ls`MagicPoint,A)
    cat [A| MpsConstantCoefficient(z) : z in ls`NestedCoordinates];

  du:=(T-UP!Evaluate(ls`PrimitiveElement, point)) mod q;
  Q:= q + ((Derivative(q)*du) mod q);
  B<a>:=quo<UP|Q>;
  // improve >> TODO
  toto:=function(z)
    return(B!(UP!z+(Derivative(UP!z)*du) mod q));
  end function;
  Fd,Toto:= FdChangeRing(Universe(ls`NestedCoordinates),B,toto);
  ls`NestedCoordinates:=[ Fd| Toto(z) : z in ls`NestedCoordinates ];
  ls`PivotInverse:=[ Fd| Toto(z) : z in ls`PivotInverse ];
end procedure;

assoc:=function(l,a)
  for i:=1 to #l do
    if l[i][1] eq a then return i; end if;
  end for;
  return 0;
end function;

/****************************************************************************
                           Lifting Public
*****************************************************************************/

LiftingState:=function()
/*
  Returns the record format used to store lifting states.
*/
  return(recformat<
    Algorithm,
    MagicPoint,
    PrimitiveElement,
    ChangeOfVariables,
    LocalVariables,
    Trace,
    NestedCoordinates,
    NestedCoordinatesPrecision,
    PivotInverse,
    PivotInversePrecision
  >);
end function;

LocalVariables:=function(lf)
/*
  Returns a change of coordinates to be used during the lifting process.
*/
  c:=CodimensionLF(lf);
  F:=lf`ResolutionField;
  return random_RandomInvertibleMatrix(F,c);
end function;

FiberFromLLS:=function(lf,lls)
/*
  Build a fiber from lf and the solutions contained in lls.
*/
  assert #lls gt 0;
  ans:=lf;
  A<a>:= MpsBaseRing(Universe(lls[1]`NestedCoordinates));
  UP<T>:= PreimageRing(A);
  F:=BaseRing(UP);
  codim:=CodimensionLF(lf);
  ans`ResolutionField:=F;
  ans`ChangeOfVariables:=lls[1]`ChangeOfVariables;
  M:=lls[1]`ChangeOfVariables`LinearPart;
  ans`ChangeOfVariables`LinearPart:=M;
  ans`MinimalPolynomial:=[UP| Modulus(MpsBaseRing(Universe(Z`NestedCoordinates))) : Z in lls];
  ans`Denominator:=[UP!1 : Z in lls];
  ans`Parametrization:= [ [UP| UP!MpsConstantCoefficient(z) : z in Z`NestedCoordinates] : Z in lls ];
  ans`MagicPoint:= lls[1]`MagicPoint;
  ans`PrimitiveElement:=lls[1]`PrimitiveElement;
  ChangeAlgebraicVariablesLF(~ans,lls[1]`LocalVariables^(-1),Vector([F| 0: i in [1..codim]]));
  return(ans);
end function;

ChangeBaseRingLS_with_map:=procedure(~ls,R,h)
/*
  Changes base ring of the lifting state ls to R, via h.
*/

  MP:=Parent(ls`PrimitiveElement);
  r:=RankLF(ls);
  n:=Rank(MP);

  // Change back local coordinates
  // This is used with lifting the integers, to avoid problems
  // with carries
  F:=BaseRing(Parent(ls`LocalVariables));
  tmp:=(InsertBlock(ScalarMatrix(n,F!1),ls`LocalVariables,r+1,r+1))^(-1);
  ls`PrimitiveElement:= Evaluate(ls`PrimitiveElement,[MP| &+[MP|tmp[i,j]*MP.j : j in [1..n]] : i in [1..n]]);
  ls`ChangeOfVariables`LinearPart*:=tmp;
  delete tmp;

  // Change ring
  ChangeUniverse(~ls`MagicPoint,R,h);
  ChangeRing(~ls`PrimitiveElement,R,h);
  MyChangeRing(~ls`ChangeOfVariables`LinearPart,R,h);
  MyChangeRing(~ls`ChangeOfVariables`AffinePart,R,h);
  MyChangeRing(~ls`LocalVariables,R,h);

  // Re-apply local variables
  MP:=Parent(ls`PrimitiveElement);
  tmp:=InsertBlock(ScalarMatrix(n,R!1),ls`LocalVariables,r+1,r+1);
  ls`PrimitiveElement:= Evaluate(ls`PrimitiveElement,[MP| &+[MP| tmp[i,j]*MP.j : j in [1..n]] : i in [1..n]]);
  ls`ChangeOfVariables`LinearPart*:=tmp;

  // Carry on change ring
  B:=Universe(ls`NestedCoordinates);
  A<a>:=MpsBaseRing(B);
  q:=Modulus(A);
  UP<T>:=PreimageRing(A);
  UPR<T>:=PolynomialRing(R);
  H:=map<UP -> UPR| x:-> UPR![R| h(z): z in Coefficients(x)]>;
  q:=H(q);
  AR<a>:=quo<UPR|q>;
  H:=map<A->AR | x:-> AR!H(UP!x)>;
  B,H:= FdChangeRing(B,AR,H);
  ls`NestedCoordinates:=[B|H(z): z in ls`NestedCoordinates];
  ls`PivotInverse:= [B|H(z): z in ls`PivotInverse];

end procedure;

ChangeBaseRingLS:=procedure(~ls,R)
/*
  Changes base ring of the lifting state ls to R.
*/
  f:=function(x) return R!x; end function;
  ChangeBaseRingLS_with_map(~ls,R, f);
end procedure;

LiftInitialization:=function(lf,l,localvariables)
/*
  It computes the nested coordinates for the lth factor of lf.
  lf must be shapelemma.
  Performs a generic change of coordinates.
  Returns an error message together with the gcd when a spliting
  occurs.
*/
  // Moving to generic coordinates.
  s:=#lf`MinimalPolynomial;
  assert l ge 1 and l le s;
  n:=NumberOfVariablesLF(lf);
  r:=RankLF(lf);
  codim:=n-r;
  F:=lf`ResolutionField;
  lfloc:=lf;
  ChangeAlgebraicVariablesLF(~lfloc,localvariables,Vector([F| 0: i in [1..codim]]));
  MakeMonicLF(~lfloc);
  // Initialisation of the multiplicity sequence and the inverses of the pivots
  q:=lfloc`MinimalPolynomial[l];
  v:=lfloc`Parametrization[l];
  m:=[1 : i in [1..codim] ];
  UP<T>:=Parent(q);
  A<a>:=quo<UP|q>;
  B:=FdAlgebra(A,m:PrettyPrint);
  locmp:= ChangeUniverse(lfloc`MagicPoint,A);
  Y:=[B | A!z*B.1 : z in v];
  pre_evaluate:=function(Yloc)
    R:=Universe(Yloc);
    F:=BaseRing(R);
    x:=[ z*R.1 : z in locmp ] cat Yloc;
    n:=#x;
    return [ &+[(F!lfloc`ChangeOfVariables`LinearPart[i,j]*R.1)*x[j] : j in [1..n]] +
      F!lfloc`ChangeOfVariables`AffinePart[i]*R.1 : i in [1..n]];
  end function;
  if not assigned lf`GenericTrace then
    FdNestedCoordinates(pre_evaluate,lf`LiftingSystem,~Y,~trace,~ipivot,~mesg);
  else
    FdNestedCoordinatesWithTrace(pre_evaluate,lf`LiftingSystem,~Y,lf`GenericTrace,~ipivot,~mesg);
    trace:=lf`GenericTrace;
  end if;
  if mesg cmpne "" then return(mesg); end if;
  ans:= rec<LiftingState()|
    Algorithm:="$filename$",
    MagicPoint:=lfloc`MagicPoint,
    PrimitiveElement:=lfloc`PrimitiveElement,
    ChangeOfVariables:=lfloc`ChangeOfVariables,
    LocalVariables:=localvariables,
    Trace:=trace,
    NestedCoordinates:=Y,
    NestedCoordinatesPrecision:=1,
    PivotInverse:=ipivot,
    PivotInversePrecision:=1
  >;
  return ans;
end function;


Lift:=procedure(~lf,~lls,stopcriterion)
  n:=NumberOfVariablesLF(lf);
  while true do
    lfloc:=FiberFromLLS(lf,lls);
    b, answer:= stopcriterion(lfloc);
    if b then lf:=answer; return; end if;
    requestedprecision:=Min(2*lls[1]`NestedCoordinatesPrecision,answer);
    vprint HenselVerbose,2:"Lifting to precision", requestedprecision;

    for l:=1 to #lls do
      vprint HenselVerbose,3:"Dealing with factor",l,"/",#lls,"of degree",Degree(lf`MinimalPolynomial[l]);
      ls:=lls[l];

      // Set precision
      F:=BaseRing(MpsBaseRing(Universe(ls`NestedCoordinates)));      
      F,h:=ChangePrecision(BaseRing(MpsBaseRing(Universe(ls`NestedCoordinates))),requestedprecision);
      ChangeBaseRingLS_with_map(~ls,F,h);
      B:=Universe(ls`NestedCoordinates);
      A:=MpsBaseRing(B);
            
      mploc:= [ (A!z)*B.1 : z in ls`MagicPoint ];
      pre_evaluate:=function(Yloc)
        R:=Universe(Yloc);
	F:=BaseRing(R);
	x:=mploc cat Yloc;
	n:=#x;
      	return [ &+[(F!ls`ChangeOfVariables`LinearPart[i,j]*R.1)*x[j]
	  : j in [1..n]] + F!ls`ChangeOfVariables`AffinePart[i]*R.1
	     : i in [1..n]];
      end function;
      FdLiftNestedCoordinates(pre_evaluate,lf`LiftingSystem,
        ~ls`NestedCoordinates,ls`Trace,~ls`PivotInverse);
      GlobalizeSolution(~ls);
      ls`NestedCoordinatesPrecision:=requestedprecision;
      lls[l]:=ls;
    end for;
  end while;
end procedure;

// TODO << ne plus supposer que c'est factoris
Split:=function(lf)
  tmp:=[];
  localvariables:=LocalVariables(lf);
  for l:=1 to NumberOfFactorsLF(lf) do
    ls:=LiftInitialization(lf,l,localvariables);
    if Type(ls) ne Rec then return ls; end if;
    i:=assoc(tmp,ls`Trace);
    if i gt 0 then
      Append(~tmp[i][2],l);
    else
      Append(~tmp,<ls`Trace,[l]>);
    end if;
  end for;
  llf:=[];
  for x in tmp do
    lfloc:=lf;
    lfloc`MinimalPolynomial:=[lf`MinimalPolynomial[l] : l in x[2]];
    lfloc`Denominator:=[lf`Denominator[l] : l in x[2]];
    lfloc`Parametrization:=[lf`Parametrization[l] : l in x[2]];
    lfloc`GenericTrace:=x[1];
    // Turn off multiplicity if detected.
    if FdIsSmoothTrace(x[1]) then
      lfloc`IsMultiple:=false;
    else
      lfloc`IsMultiple:=true;
    end if;
    Append(~llf,lfloc);
  end for;
  return llf;
end function;

/*****************************************************************************
                                Intrinsics
******************************************************************************/

// renames intrinsics





// # 1 "hensel_common.h" 1
// -*-magma-*-
// $Header$
// $Log$

/*****************************************************************************
                                Intrinsics
******************************************************************************/

intrinsic HasLiftingPointLF_fda(lf::Rec)->BoolElt
{
 Returns whether any lifting process on lf will be ok or not.
}
  if IsWholeSpaceLF(lf) then return(true); end if;
  localvariables:=LocalVariables(lf);
  for l:=1 to NumberOfFactorsLF(lf) do
    ls:= LiftInitialization(lf,l,localvariables);
    if Type(ls) ne Rec then return false; end if;
  end for;
  return true;  
end intrinsic;

intrinsic LiftCurveLF_fda(~lf::Rec,destpoint,precision)
{
  See documentation in hensel.mtx.
}
  IndentPush();
  vprint HenselVerbose,1:"--> LiftCurveLF";
  begintime:=Cputime();
  vprint HenselVerbose,2:"Degrees of the factors:",Sprint([Degree(z) : z in lf`MinimalPolynomial]);
  r:=RankLF(lf);
  require #destpoint eq r: "Wrong size of 2nd argument";
  F:=lf`ResolutionField;
  LS:=LaurentSeriesRing(F); AssignNames(~LS,[Sprint(ParentBbpLF(lf).r)]);
  LS`Precision:=1;
  lls:=[];
  localvariables:=LocalVariables(lf);
  for l:=1 to NumberOfFactorsLF(lf) do
    ls:=LiftInitialization(lf,l,localvariables);
    if Type(ls) ne Rec then lf:=ls; IndentPop(); return; end if;
    ChangeBaseRingLS(~ls,LS);
    ls`MagicPoint := [ LS| LS!ls`MagicPoint[j]
      +LS.1*(LS!destpoint[j]-LS!ls`MagicPoint[j]) : j in [1..r]];
    Append(~lls,ls);
  end for;
  Lift(~lf, ~lls, hensel_base__StopCriterion_Bound(precision));
  vprint HenselVerbose,1:"<-- LiftCurveLF, elapsed time:", Cputime()-begintime;
  IndentPop();
end intrinsic;

intrinsic LiftIntegersLF_fda(~lf::Rec)
{
  See documentation in hensel.mtx.
}
  MakeMonicLF(~lf);
  if IsWholeSpaceLF(lf) then return; end if;
  require HasShapeLemmaParametrizationLF(lf): "ShapeLemma parametrization required";
  IndentPush();
  vprint HenselVerbose,1:"--> LiftIntegersLF";
  vprint HenselVerbose,2:"Degrees of the factors:",Sprint([Degree(z) : z in lf`MinimalPolynomial]);
  begintime:=Cputime();
  // initialization
  K:=lf`ResolutionField;
  PA:=pAdicIntegers(#K,1);
  PA,h:=ChangePrecision(PA,1);
  lls:=[];
  localvariables:=LocalVariables(lf);
  for l:=1 to NumberOfFactorsLF(lf) do
    ls:=LiftInitialization(lf,l,localvariables);
    if Type(ls) ne Rec then lf:=ls; IndentPop(); return; end if;
    ChangeBaseRingLS(~ls,PA);
    Append(~lls,ls);
  end for;
  stopcriterion:=hensel_base__StopCriterion_Integers();
  Lift(~lf, ~lls, stopcriterion);
  vprint HenselVerbose,1:"<-- LiftIntegersLF, elapsed time:", Cputime()-begintime;
  IndentPop();
end intrinsic;

intrinsic LiftSplitLF_fda(lf) -> SeqEnum
{
  See documentation in hensel.mtx.
}
  IndentPush();
  vprint HenselVerbose: "--> LiftSplitLF";
  tmp:= Split(lf);
  vprint HenselVerbose: "<-- LiftSplitLF";
  IndentPop();
  return tmp;
end intrinsic;

// # 309 "hensel_fda.mtx" 2
