// # 1 "intcase.mtx"
// $Header$
// # 1 "header.h" 1
/*
///////////////////////////////////////////////////

   Kronecker Package version 0.166-9 for Magma

///////////////////////////////////////////////////

Date: sam jun  8 14:57:49 UTC 2002
Copyright (C) 1999--2002, G. Lecerf, Centre National de la Recherche Scientifique
Location: 
          Laboratoire de mathmatiques, LAMA - UMR 8100
          Universit de Versailles St-Quentin-en-Yvelines
          45 avenue des Etats-Unis - Btiment Fermat
          78035 Versailles, France
Url: http://kronecker.medicis.polytechnique.fr/
Bug report to: Gregoire.Lecerf@math.uvsq.fr

!!! WARNING, this package comes with NO WARRANTY !!!
*/

// # 3 "intcase.mtx" 2
// $Log$

// # 1 "macros.h" 1
// $Header$
// $Log$


















declare verbose BbpVerbose,5;
GlobalBbpVerbose:=[0,0,0,0,0,5];
declare verbose FdaVerbose,5;
GlobalFdaVerboseVerbose:=[0,0,0,1,2,3];
declare verbose FiberVerbose,5;
GlobalFiberVerbose:=[0,1,2,3,4,5];
declare verbose GeometricSolveVerbose,5;
GlobalGeometricSolveVerbose:=[0,1,2,3,4,5];
declare verbose HenselVerbose,5;
GlobalHenselVerboseVerbose:=[0,1,2,3,3,4];
declare verbose IntersectionVerbose,5;
GlobalIntersectionVerbose:=[0,1,2,2,3,4];
declare verbose NonUniversalVerbose,5;
GlobalNonUniversalVerbose:=[0,1,2,3,4,5];
declare verbose AlgebraicApproximantVerbose,5;
GlobalAlgebraicApproximantVerbose:=[0,0,0,1,2,3,5];




















// MathML support

declare verbose KroneckerMathMLVerbose,5;









// # 6 "intcase.mtx" 2
import "hensel_base.m": hensel_base__FromSeriesToRationalCoefficients, hensel_base__FromSeriesToRationalCoefficients_Pade, hensel_base__EvaluateAtOne, hensel_base__MultiplyByCommonDenominator, hensel_base__StopCriterion_Bound, hensel_base__StopCriterion_Integers, hensel_base__HeuristicCombineFactorized;// #import hensel_base.m


// #Private
intrinsic RationalReconstruction(s::[]) -> BoolElt,[]
{
  
    If there exists an intrinsic RationalReconstruction
    which can be applied to each element of s then the function
    returns b,t, where b is a boolean telling whether
    RationalReconstruction has returned true for each
    element of s.
    If b is true then t is the sequence
    of the reconstructed objects.
  
  
    It is not checked that such the required
    RationalReconstruction exists.
  
}
  S:=Universe(s);
  b,t:=RationalReconstruction(S!0);
  assert b;
  R:=Parent(t);
  ans:=[R| R!0 : i in [1..#s]];
  for i:=1 to #s do
    b,t:=RationalReconstruction(s[i]);
    if not b then return false,s; end if;
    ans[i]:=t;
  end for;
  return true,ans;
end intrinsic;

intrinsic RationalReconstruction(s::RngMPolElt) -> BoolElt,RngMPolElt
{
  Rational reconstruction of the coefficients of a multivariate polynomial.
}
  MP:=Parent(s);
  F:=BaseRing(MP);
  n:=Rank(MP);
  b,t:=RationalReconstruction(F!0);
  assert b;
  R:=Parent(t);
  MPout:=PolynomialAlgebra(R,n);
  b,t:=RationalReconstruction(Coefficients(s));
  if not b then return false,MPout!0; end if;
  mon:=Monomials(s);
  return true,&+[MPout| (MPout!t[i])*&*[MPout| (MPout.j)^Degree(mon[i],j)
    : j in [1..n]] : i in [1..#mon]];
end intrinsic;

intrinsic RationalReconstruction(s::FldFunRatElt) -> BoolElt,FldFunRatElt
{
  Rational reconstruction of the coefficients of a rational function.
}
  MF:=Parent(s);
  MP:=IntegerRing(MF);
  b0,t0:=RationalReconstruction(MP!0);
  assert b0;
  MFout:=FieldOfFractions(Parent(t0));
  b1,t1:=RationalReconstruction(Numerator(s));
  b2,t2:=RationalReconstruction(Denominator(s));
  if not b1 or not b2 then return false,MFout!0; end if;
  return true, (MFout!t1)/(MFout!t2);
end intrinsic;

intrinsic MyRationalReconstruction(a::AlgMatElt) -> BoolElt,Mtrx
{
  Rational reconstruction of the entries of a matrix.
}
  A:=Parent(a);
  R:=BaseRing(A);
  n:=NumberOfRows(a);
  m:=NumberOfColumns(a);
  b,t:=RationalReconstruction(R!0);
  assert b;
  S:=Parent(t);
  b,t:=RationalReconstruction(Eltseq(a));
  if not b then return false,0; end if;
  return true,Matrix(n,m,t);
end intrinsic;

intrinsic MyRationalReconstruction(a::ModTupRngElt) -> BoolElt,Mtrx
{
  Rational reconstruction of the entries of a matrix.
}
  A:=Parent(a);
  R:=BaseRing(A);
  n:=NumberOfRows(a);
  m:=NumberOfColumns(a);
  b,t:=RationalReconstruction(R!0);
  assert b;
  S:=Parent(t);
  b,t:=RationalReconstruction(Eltseq(a));
  if not b then return false,0; end if;
  return true,Vector(t);
end intrinsic;

// #Public


//////////////////////////
// #Section=Find small fibers
//////////////////////////

intrinsic FindSmallMagicPointLF(~lf::Rec)
{
  
     It changes lf`MagicPoint into one of small height.
     The fiber lf must be isolated.
  
}
  r:=RankLF(lf);
  if r eq 0 then return; end if;
  IndentPush();
  vprint HenselVerbose,1:"--> FindSmallMagicPointLF";
  loclf:="";
  height:=2;
  failed:=0;
  K:=lf`ResolutionField;
  while Type(loclf) eq MonStgElt do
    mp:= [K|Random(height) : i in [1..r]];
    vprint HenselVerbose,2:"Trying magic point",Sprintf("%o",mp);
    loclf:=lf;
    // TODO << improve
    MakeShapeLemmaParametrizationLF(~loclf);
    ChangeMagicPointLF(~loclf,mp);
    if Type(loclf) ne MonStgElt then
      MakeShapeLemmaParametrizationLF(~loclf);
      if Type(loclf) ne MonStgElt then
        if HasLiftingPointLF(loclf) then
          lf:=loclf;
          MakeMonicLF(~lf);
          vprint HenselVerbose,2:"<-- FindSmallMagicPointLF";
          IndentPop();
          return;
        end if;
      end if;
    else
      lf:=loclf;
      vprint HenselVerbose,1:"<-- FindSmallMagicPointLF";
      IndentPop();
      return;
    end if;
    loclf:="";
    failed+:=1;
    if failed gt 2 then height*:=3; failed:=1; end if;
  end while;
  vprint HenselVerbose,1:"<-- FindSmallMagicPointLF";
  IndentPop();
end intrinsic;

intrinsic FindSmallMagicPointLF(~llf::[])
{
 It iterates FindSmallMagicPointLF on each element of llf.
}
  for i:=1 to #llf do
    lf:=llf[i];
    FindSmallMagicPointLF(~lf);
    if Type(lf) eq MonStgElt then llf:=lf; return; end if;
    llf[i]:=lf;
  end for;
end intrinsic;

intrinsic FindSmallNoetherPositionLF(~lf::Rec)
{
  
      lf, a isolated LiftingFiber.
  
  
     It changes lf`ChangeOfVariables into a smaller one.
  
  
     The function raises an error if lf is not irreducible
     with respect to the lifting process (FDA).
  
}
  IndentPush();
  MP:=Parent(lf`PrimitiveElement);
  vprint HenselVerbose,1:"--> FindSmallNoetherPositionLF";
  ChangeBackAlgebraicVariablesLF(~lf);
  ChangeBackFreeVariablesLF(~lf);
  height:=1;
  failed:=0;
  n:=NumberOfVariablesLF(lf);
  r:=RankLF(lf);
  if r eq 0 then
    vprint HenselVerbose,1:"<-- FindSmallNoetherPositionLF";
    IndentPop();
    return;
  end if;
  delta:=DegreeLF(lf);
  m0:=lf`ChangeOfVariables`LinearPart;
  M:=Parent(m0);
  v0:=lf`ChangeOfVariables`AffinePart;
  V:=Parent(v0);

  while true do
    // Build a destination matrix of given height.
    m:=M!1;
    for i:=1 to r do
      for j:=r+1 to n do 
        m[i,j]:=Random(height);
      end for;
    end for;

    v:=V!&cat[[Random(height): i in [1..r]], [ 0 : i in [r+1..n]]];

    vprint HenselVerbose,2:"Trying change of variables",m,v;
    loclf:=lf;

    // In order to be efficient we perform r successive homotopies.
    for i:=1 to r do
      for j:=1 to n do
        m0[i,j]:= m[i,j];
      end for;
      m[i,i]:=0;
      ChangeCoordinatesLF(~loclf,i,[m[i,j]: j in [1..n]],v[i]);
      if Type(loclf) eq MonStgElt then
        if loclf eq "Not invertible" then
          lf:="Failed";
          vprint HenselVerbose,1:"<-- FindSmallNoetherPositionLF";
          IndentPop();
          return;
        else
      	loclf:="Failed"; break;
        end if;
      end if;
      // Test if everyting is OK.
      if DegreeLF(loclf) eq delta then
        MakeShapeLemmaParametrizationLF(~loclf);
        if Type(loclf) eq MonStgElt then loclf:="Failed"; break; end if;
        if not HasLiftingPointLF(loclf) then
          vprint HenselVerbose,2:"Lifting point lost!";
	  loclf:="Failed"; break;
	end if;
        if not VerifyLF(loclf) then
          vprint HenselVerbose,2:"Correctness lost!";
	  loclf:="Failed"; break;
	end if;
      else
        vprint HenselVerbose,2:"Degree deficiency!";
	loclf:="Failed"; break;
      end if;
    end for;

    if Type(loclf) ne MonStgElt then
      lf:=loclf;
      MakeMonicLF(~lf);
      break;
    end if;

    failed+:=1;
    if failed gt 2 then height*:=2; failed:=1; end if;

    m0:=lf`ChangeOfVariables`LinearPart;
    v0:=lf`ChangeOfVariables`AffinePart;
  end while;
  vprint HenselVerbose,1:"<-- FindSmallNoetherPositionLF";
  IndentPop();
end intrinsic;

intrinsic FindSmallNoetherPositionLF(~llf::[])
{
 It iterates FindSmallNoetherPositionLF on each element of llf.
}
  for i:=1 to #llf do
    lf:=llf[i]; FindSmallNoetherPositionLF(~lf);
    if Type(lf) eq MonStgElt then llf:=lf; return; end if;
    llf[i]:=lf;
  end for;
end intrinsic;

intrinsic FindSmallPrimitiveElementLF(~lf::Rec)
{
  
     It changes lf`PrimitiveElement into one of small height.
  
}
  IndentPush();
  vprint HenselVerbose,1:"--> FindSmallPrimitiveElementLF";
  MP:=Parent(lf`PrimitiveElement);
  r:=DimensionLF(lf);
  n:=Rank(MP);

  for i := RankLF(lf)+1 to Rank(MP) do
    vprint HenselVerbose,2:"Trying ",MP.i;
    loclf:=lf;
    ChangePrimitiveElementLF(~loclf,MP.i);
    if Type(loclf) ne MonStgElt then
      lf:=loclf;
      MakeMonicLF(~lf);
      vprint HenselVerbose,1:"<-- FindSmallPrimitiveElementLF ...";
      IndentPop();
      return;
    end if;
  end for;

  height:=2;
  failed:=0;
  special:=true;

  while Type(loclf) eq MonStgElt do
    if special then
      u:=&+[MP | i*MP.i : i in [DimensionLF(lf)+1..Rank(MP)]];
      special:= false;
    else
      tmp:=[ Random(height) : i in [r+1..n]];
      tmp1:=[z : z in tmp | z ne 0];
      if IsEmpty(tmp1) then continue; end if;
      ctmp:=Gcd(tmp1);
      u:=&+[MP | (tmp[i-r] div ctmp)*MP.i : i in [r+1..n]];
    end if;
    vprint HenselVerbose,2:"Trying primitive element",u;
    loclf:=lf;
    ChangePrimitiveElementLF(~loclf,u);
    if Type(loclf) ne MonStgElt then
      lf:=loclf;
      MakeMonicLF(~lf);
      vprint HenselVerbose,1:"<-- FindSmallPrimitiveElementLF ...";
      IndentPop();
      return;
    end if;
    loclf:="";
    failed+:=1;
    if failed gt 3*Rank(MP) then height*:=2; failed:=1; end if;
  end while;
end intrinsic;

intrinsic FindSmallPrimitiveElementLF(~llf::[])
{
 It iterates FindSmallPrimitiveElementLF on each element of llf.
}
  for i:=1 to #llf do
    lf:=llf[i];
    FindSmallPrimitiveElementLF(~lf);
    if Type(lf) eq MonStgElt then llf:=lf; return; end if;
    llf[i]:=lf;
  end for;
end intrinsic;

////////////////////////////////
// #Section=Rational reconstruction
////////////////////////////////

intrinsic RationalReconstructionLF(lf::Rec) -> BoolElt,Rec
{
 
   It returns b,lfi, where b is a boolean and lfi
   is a lifting fiber.
 
 
   The resolution field of lf must be a valuated ring for which there
   exists a RationalReconstruction intrinsic.
   If all these reconstructions succeed then b is true
   and lfi contains the reconstruction, otherwise b is false.
 
}
  IndentPush();
  vprint HenselVerbose,1:"--> RationalReconstructionLF";
  ratlf:=lf;
  F:=ratlf`ResolutionField;
  UP0:=Universe(lf`MinimalPolynomial);
  b,t:=RationalReconstruction(F!0);
  assert b;
  R:=Parent(t);
  ratlf`ResolutionField:=R;
  UP<T>:=PolynomialAlgebra(R);

  b,t:=RationalReconstruction(lf`MagicPoint);
  if not b then IndentPop(); return false,0; end if;
  ratlf`MagicPoint:=t;

  b,t:=RationalReconstruction(lf`PrimitiveElement);
  if not b then IndentPop(); return false,0; end if;
  ratlf`PrimitiveElement:=t;

  b,t:=MyRationalReconstruction(lf`ChangeOfVariables`LinearPart);
  if not b then IndentPop(); return false,0; end if;
  ratlf`ChangeOfVariables`LinearPart:=t;
  
  b,t:=MyRationalReconstruction(lf`ChangeOfVariables`AffinePart);
  if not b then IndentPop(); return false,0; end if;
  ratlf`ChangeOfVariables`AffinePart:=t;

  q:=lf`MinimalPolynomial[1];
  b,t:=RationalReconstruction(Coefficients(q));
  if not b then IndentPop(); return false,0; end if;
  ratlf`MinimalPolynomial:=[UP!t];

  q:=ratlf`Denominator[1];
  b,t:=RationalReconstruction(Coefficients(q));
  if not b then IndentPop(); return false,0; end if;
  ratlf`Denominator:=[UP!t];

  w:=ratlf`Parametrization[1];
  ratlf`Parametrization:=[[UP!0 : i in [1..#w]]];
  for i:=1 to #w do
    b,t:=RationalReconstruction(Coefficients(w[i]));
    if not b then IndentPop(); return false,0; end if;
    ratlf`Parametrization[1][i]:=UP!t;    
  end for;
  vprint HenselVerbose,1:"<-- RationalReconstructionLF";
  IndentPop();
  return true,ratlf;
end intrinsic;

intrinsic RationalReconstructionLF(llf::[]) -> BoolElt,[]
{
 It iterates RationalReconstructionLF over each element of llf.
}
  answer:=[Universe(llf)|];
  for lf in llf do
    b,tmp:=RationalReconstructionLF(lf);
    if not b then return false,answer; end if;
    Append(~answer,tmp);
  end for;
  return true,answer;
end intrinsic;

//////////////////////////
// #Section=Lift the integers
//////////////////////////

intrinsic LiftIntegersLF(~lf::Rec)
{
  
     lf, an isolated lifting fiber.
  
  
    It lifts the integers of lf.
  
  
     It may never stop, when the modular resolution
      is not lucky.
     cf. common requirements above.
  
}
  MakeMonicLF(~lf);
  if IsWholeSpaceLF(lf) then return; end if;
  require HasShapeLemmaParametrizationLF(lf): "ShapeLemma parametrization required";
  hensel_base__HeuristicCombineFactorized(~lf);
  if IsMultipleLF(lf) then
    LiftIntegersLF_fda(~lf);
  else
    LiftIntegersLF_newton(~lf);
  end if;
end intrinsic;

intrinsic LiftIntegersLF(~llf::[])
{
  It iterates LiftIntegersLF over each element of llf.
}
  answer:=[];
  for i:=1 to #llf do
    lf:=llf[i];
    LiftIntegersLF(~lf);
    if Type(lf) eq MonStgElt then llf:=lf; return; end if;
    Append(~answer,lf);
  end for;
  llf:=answer;
end intrinsic;

