// # 1 "irredec.mtx"
// $Header$
// # 1 "header.h" 1
/*
///////////////////////////////////////////////////

   Kronecker Package version 0.166-9 for Magma

///////////////////////////////////////////////////

Date: sam jun  8 14:57:49 UTC 2002
Copyright (C) 1999--2002, G. Lecerf, Centre National de la Recherche Scientifique
Location: 
          Laboratoire de mathmatiques, LAMA - UMR 8100
          Universit de Versailles St-Quentin-en-Yvelines
          45 avenue des Etats-Unis - Btiment Fermat
          78035 Versailles, France
Url: http://kronecker.medicis.polytechnique.fr/
Bug report to: Gregoire.Lecerf@math.uvsq.fr

!!! WARNING, this package comes with NO WARRANTY !!!
*/

// # 3 "irredec.mtx" 2
// $Log$

// # 1 "macros.h" 1
// $Header$
// $Log$


















declare verbose BbpVerbose,5;
GlobalBbpVerbose:=[0,0,0,0,0,5];
declare verbose FdaVerbose,5;
GlobalFdaVerboseVerbose:=[0,0,0,1,2,3];
declare verbose FiberVerbose,5;
GlobalFiberVerbose:=[0,1,2,3,4,5];
declare verbose GeometricSolveVerbose,5;
GlobalGeometricSolveVerbose:=[0,1,2,3,4,5];
declare verbose HenselVerbose,5;
GlobalHenselVerboseVerbose:=[0,1,2,3,3,4];
declare verbose IntersectionVerbose,5;
GlobalIntersectionVerbose:=[0,1,2,2,3,4];
declare verbose NonUniversalVerbose,5;
GlobalNonUniversalVerbose:=[0,1,2,3,4,5];
declare verbose AlgebraicApproximantVerbose,5;
GlobalAlgebraicApproximantVerbose:=[0,0,0,1,2,3,5];




















// MathML support

declare verbose KroneckerMathMLVerbose,5;









// # 6 "irredec.mtx" 2
import "hensel_base.m": hensel_base__FromSeriesToRationalCoefficients, hensel_base__FromSeriesToRationalCoefficients_Pade, hensel_base__EvaluateAtOne, hensel_base__MultiplyByCommonDenominator, hensel_base__StopCriterion_Bound, hensel_base__StopCriterion_Integers, hensel_base__HeuristicCombineFactorized;// #import hensel_base.m


// #Public
// Irreducible decomposition
// #Package=Factorization

///////////////////////
// #Section=Factorization
///////////////////////

// In development.

// #Private
RupprechtFactorizationLF:=function(orglf,lf)
/*
Rupprecht's second order method.
*/
  s:=#lf`MinimalPolynomial;
  ans:=[];  
  remains:={1..s};
  k:=1;
  while k le s div 2 do 
    print(k);
    todo:=Permutations(remains,k);
    if IsEmpty(todo) then k+:=1; continue; end if;
    for e in todo do
      cq:=&+[Coefficient(lf`MinimalPolynomial[l],
               Degree(lf`MinimalPolynomial[l])-1): l in e];
      if Coefficient(cq,2) eq 0 then
        delta:= &+[Degree(lf`MinimalPolynomial[l]): l in e];
        vprint GeometricSolveVerbose: "Found factor of degree",delta;
        Append(~ans,e);
        remains diff:=SequenceToSet(e);
        k-:=1;
        break;
      end if;
    end for;
    k+:=1;
  end while;
  if not IsEmpty(remains) then
    Append(~ans,SetToSequence(remains));
  end if;
  // post traitment.
  llf:=[];
  vprint GeometricSolveVerbose: "Combination found",ans;
  for e in ans do
    loclf:=orglf;
    loclf`MinimalPolynomial:=[orglf`MinimalPolynomial[l]: l in e];
    loclf`Denominator:=[orglf`Denominator[l]: l in e];
    loclf`Parametrization:=[orglf`Parametrization[l]: l in e];
    Append(~llf,loclf);
  end for;
  return(llf);
end function;

// #Public

intrinsic TrueFactorizationLF(lf::Rec)->SeqEnum
{
}
  if IsWholeSpaceLF(lf) then return([lf]); end if;
  if RankLF(lf) eq 0 then return([lf]); end if;
  IndentPush();
  vprint GeometricSolveVerbose: "--> TrueFactorizationLF";

  llf:=lf;
  r:=#lf`MagicPoint;
  destpoint:=[Rationals()| Random(10^4) : i in [1..r]];
  ////// TODO random points should go into random files !!!
  newlf:=lf;
  LiftCurveLF(~newlf,destpoint,3);
  answer :=RupprechtFactorizationLF(lf,newlf);

  /* TODO : en test
  newlf:=lf;
  delta:=DegreeLF(lf);
  s:=#lf`MinimalPolynomial;
  LiftCurveLF(~newlf,destpoint,s+1);

  traces:=[ Coefficient(z, Degree(z)-1) : z in newlf`MinimalPolynomial];
  traces:=[ Derivative(Derivative(z)): z in traces];
  KUKU(); traces;
  PadeHermite_BeLa_superfast(traces,s-1,[0: i in [1..s]]); 
  
  Fin des tests, a semble bien marcher */
  
  vprint GeometricSolveVerbose: "<-- TrueFactorizationLF";
  IndentPop();
  return(answer);

end intrinsic;

intrinsic TrueFactorizationLF(llf::[])->.
{
}
  ans:=[];
  for lf in llf do
    ans cat:= TrueFactorizationLF(lf);
  end for;
  return(ans);

end intrinsic;
