// # 1 "mathml.mtx"

// # 1 "macros.h" 1
// $Header$
// $Log$


















declare verbose BbpVerbose,5;
GlobalBbpVerbose:=[0,0,0,0,0,5];
declare verbose FdaVerbose,5;
GlobalFdaVerboseVerbose:=[0,0,0,1,2,3];
declare verbose FiberVerbose,5;
GlobalFiberVerbose:=[0,1,2,3,4,5];
declare verbose GeometricSolveVerbose,5;
GlobalGeometricSolveVerbose:=[0,1,2,3,4,5];
declare verbose HenselVerbose,5;
GlobalHenselVerboseVerbose:=[0,1,2,3,3,4];
declare verbose IntersectionVerbose,5;
GlobalIntersectionVerbose:=[0,1,2,2,3,4];
declare verbose NonUniversalVerbose,5;
GlobalNonUniversalVerbose:=[0,1,2,3,4,5];
declare verbose AlgebraicApproximantVerbose,5;
GlobalAlgebraicApproximantVerbose:=[0,0,0,1,2,3,5];




















// MathML support

declare verbose KroneckerMathMLVerbose,5;









// # 3 "mathml.mtx" 2


print_minimal_polynomial:=procedure(~F,x)
  UP<T>:=Parent(x);
  K:=BaseRing(UP);
  if Type(K) eq FldFunRat then
    K:=IntegerRing(K);
    AssignNames(~K,[ "y" cat Sprint(i) : i in [1..Rank(K)]]);
    UP<T>:=PolynomialRing(K);  
  end if;
  MathML(~F,UP!x);
  MathML_tag_1(~F, "mo", "=");
  MathML(~F,0);
end procedure;

print_primitive_element:=procedure(~F,x)
  MathML_tag_1(~F,"mi", "T");
  MathML_tag_1(~F, "mo", "=");
  R:=Parent(x);
  n:=Rank(R);
  R:=BaseRing(R);
  MP:=PolynomialRing(R,n);
  AssignNames(~MP,[ "y" cat Sprint(i) : i in [1..n]]);
  MathML(~F, MP!x: max:=-1);
end procedure;
		
print_magic_point:=procedure(~F,x)
  first:=true;
  for i:=1 to #x do
    if not first then
      MathML_tag_1(~F,"mo",","); 
      MathML_tag_1(~F, "mn", "&InvisibleTimes;");
    end if; 
    MathML(~F,"y" cat Sprint(i));
    MathML_tag_1(~F,"mo","="); 
    MathML(~F,x[i]);
    first:=false;
  end for;
end procedure;
		
print_parametrization:=procedure(~F, n, deno, x, qp)
  if #x gt 1 then
     MathML_mfenced_begin(~F,"{"," ");
  else 
     MathML_mfenced_begin(~F," "," ");
  end if; 
  MathML_tag_begin(~F,"mtable");
  for i:=1 to #x by 1 do
    MathML_tag_begin(~F,"mtr");  
    MathML_tag_begin(~F,"mtd");
    if Degree(deno) gt 0 or
       (Degree(deno) eq 0 and Coefficient(deno,0) ne 1) then 
      if deno eq qp then
        MathML_tag_1(~F,"mi","q'");
      else
        MathML_tag_1(~F,"mo","(");
        MathML(~F,deno);
        MathML_tag_1(~F,"mo",")");
      end if;
    end if; 
    MathML_tag_end(~F,"mtd");
    MathML_tag_begin(~F,"mtd");      
    MathML(~F,"y" cat Sprint(i+n-#x));
    MathML_tag_end(~F,"mtd");
    MathML_tag_begin(~F,"mtd");      
    MathML_tag_1(~F,"mo", "=");
    MathML_tag_end(~F,"mtd");
    MathML_tag_begin(~F,"mtd":
      attributes:=rec<MathMLAttributes()|columnalign:="left">); 
    MathML(~F,x[i]);
    MathML_tag_end(~F,"mtd");
    MathML_tag_end(~F,"mtr");  
  end for;
  MathML_tag_end(~F,"mtable");
  MathML_tag_end(~F,"mfenced");  
end procedure;



// TODO--1 (squaring bivariate objets takes time)







opConst:= {0, 1};
opUnary:= {2, 3};
opBinary:= {4, 5, 6};

forward MathML_SubPrintBbp;

MathML_SubPrintSeqOp:=procedure(~F,~dag,t,u,v)
   MathML_SubPrintBbp(~F,~dag,u);
   MathML(~F,t);
   MathML_SubPrintBbp(~F,~dag,v);
end procedure;  

MathML_SubPrintBbp:=procedure(~F,~dag, x)

       e:=dag`Ops[x[1],x[2]];
       case e[1] :
            when 1 : MathML(~F,Sprint(dag`Variables[e[2]]));
            when 0 : MathML(~F,Sprint(dag`Constants[e[2]]));
            when 4 : MathML_tag_1(~F,"mo","( ");
                         MathML_SubPrintSeqOp(~F,~dag, "+", [e[2],e[3]], [e[4],e[5]]); 
                         MathML_tag_1 (~F,"mo", " )");
            when 6 : MathML_tag_1 (~F, "mo", "( ");
                         MathML_SubPrintSeqOp(~F,~dag, "*", [e[2],e[3]], [e[4],e[5]]); 
                         MathML_tag_1 (~F, "mo", " )");
            when 3 : MathML_tag_1 (~F, "mo", "(-(");
                         $$(~F,~dag,[e[2],e[3]]);
                         MathML_tag_1 (~F, "mo", "))");
            when 5 : MathML_tag_1 (~F, "mo", "( ");
                         MathML_SubPrintSeqOp(~F,~dag, "-", [e[2],e[3]],[e[4],e[5]]);
                         MathML_tag_1 (~F, "mo", ")");
            when 2 : if not dag`Ops[e[2],e[3]][1] in [1,0] then
                           MathML_tag_1 (~F, "mo", "( ");
			 end if;
                         $$(~F,~dag,[e[2],e[3]]);
                         if not dag`Ops[e[2],e[3]][1] in [1,0] then
                           MathML_tag_1 (~F, "mo", ") ");
			 end if;
                         MathML(~F," ^2");
       end case;
                
end procedure ;

intrinsic MathML_PrintBbp(~F, e::Rec)
{
  it prints in a html file the expression represented by
}        
  if Type(e) eq Rec then
       dag:= e`Parent`Dag;
       x  := e`Address;
       MathML_SubPrintBbp(~F,~dag, x);
  else
       print(e);
  end if;
end intrinsic; 

intrinsic print_lifting_system(~F, s::[])
{ 
 prints a sequence of Blackboxpolynomial
}
  first:=true;
  MathML_mfenced_begin(~F,"[","]");
  MathML_tag_begin(~F,"mtable");
  for e in s do
        MathML_tag_begin(~F,"mtr");
        MathML_tag_begin(~F,"mtd");
     	MathML_PrintBbp(~F,e);
        MathML_tag_end(~F,"mtd");
        MathML_tag_end(~F,"mtr"); 
  end for;   
  MathML_tag_end(~F,"mtable");
  MathML_tag_end(~F,"mfenced");
end intrinsic;
	
/********************************************************************************
			fiber
  *********************************************************************************/

replace_lt_and_gt:=function(s)
  ans:="";
  deb:=1;
  for i:=1 to #s do
    if s[i] eq "<" then
      ans cat:=s[deb..i-1] cat " &lt; ";
      deb:=i+1; continue;
    end if;
    if s[i] eq ">" then
      ans cat:= s[deb..i-1] cat " &gt; ";
      deb:=i+1; continue;
    end if;
  end for;
  ans cat:=s[deb..#s];
  return ans;
end function;

    
intrinsic MML_PrintLF(~F,lf::Rec)
{
 general procedure for a fiber file.
}
  
  M:=lf`ChangeOfVariables`LinearPart;
  B:=lf`ChangeOfVariables`AffinePart;
  codim:= NumberOfRows(M);
  n:=Rank(lf`ParentBbp);
  
  nb_poly:=0;
  MathML_tag_begin(~F,"ul");
  MathML_tag_begin(~F,"li");
  MathML_tag_1(~F,"B","Dimension:");
  MathML_tag_begin(~F,"math");
  MathML(~F,RankLF(lf));
  MathML_tag_end(~F,"math");
  MathML_tag_end(~F,"li");
  MathML_tag_begin(~F,"li");
  MathML_tag_1(~F,"B","Degree:");
  MathML_tag_begin(~F,"math");
  MathML(~F,DegreeLF(lf));
  MathML_tag_end(~F,"math");
  MathML_tag_end(~F,"li");

  MathML_tag_begin(~F,"li");
  if IsMultipleLF(lf) then
      MathML_tag_1(~F,"I","with multiplicity");
  else 
      MathML_tag_1(~F,"I","without multiplicity");
  end if;
  MathML_tag_end(~F,"li");

  K:=lf`ResolutionField;
  if Type(K) in [FldFunRat] then
    AssignNames(~lf`ResolutionField,[ "y" cat Sprint(i): i in [1..Rank(K)]]);
  end if;
  
  MathML_tag_begin(~F, "li");
  MathML_tag_1(~F, "B", "Resolution field:");
  MathML(~F, Sprint(lf`ResolutionField));
  MathML_tag_end(~F, "li");

  MathML_tag_begin(~F, "li");
  MathML_tag_1(~F, "B", "Change of variables:");
  MathML_tag_begin(~F,"math");
  MathML(~F,Vector(lf`ParentBbp`Dag`Variables));
  MathML_tag_1(~F, "mo", "=");
  MathML(~F,M);

  MP:=Parent(lf`PrimitiveElement);
  n:=Rank(MP);
  R:=BaseRing(MP);
  MP:=PolynomialRing(R,n);
  AssignNames(~MP,[ "y" cat Sprint(i) : i in [1..n]]);
  MathML(~F,Vector(MP,[MP.i : i in [1..n]]));
  
  MathML(~F,"+");
  MathML(~F, B);  
  MathML_tag_end(~F,"math");
  MathML_tag_end(~F,"li");

  mp:=lf`MagicPoint;
  printmp:=true;
  if #mp eq 0 then printmp:=false; end if;
  U:=Universe(mp);
  if Type(U) eq FldFunRat then
    if &and[ mp[i] eq U.i : i in [1..Rank(U)]] then printmp:=false; end if;
  end if;
  
  if printmp then
    MathML_tag_begin(~F, "li");
    MathML_tag_1(~F, "B", "Specialization point:");
    MathML_tag_begin(~F,"math");
    print_magic_point(~F,lf`MagicPoint);
    MathML_tag_end(~F,"math");
    MathML_tag_end(~F,"li");
  end if;
  
  MathML_tag_begin(~F, "li");
  MathML_tag_1(~F, "B", "Primitive Element: ");
  MathML_tag_begin(~F,"math");
  print_primitive_element(~F,lf`PrimitiveElement);  
  MathML_tag_end(~F,"math");
  MathML_tag_end(~F,"li");

  MathML_tag_begin(~F, "li");
  MathML_tag_1(~F, "B", " Parametrization: ");
  MathML_tag_begin(~F,"ul");
  for i:=1 to #lf`MinimalPolynomial do
        MathML_tag_begin(~F, "li");
    	MathML_tag_begin(~F, "math");
	MathML_tag_1(~F,"mi","q");
        MathML_tag_1(~F,"mo","=");
    	print_minimal_polynomial(~F,lf`MinimalPolynomial[i]);
        MathML_tag_1(~F,"mo", ",");
        MathML_tag_1(~F,"br", "");
    	MathML_tag_end(~F, "math");
   	MathML_tag_begin(~F, "math");
    	print_parametrization(~F, n, lf`Denominator[i],lf`Parametrization[i], Derivative(lf`MinimalPolynomial[i]));
    	MathML_tag_end(~F, "math");
        MathML_tag_end(~F, "li"); 	
  end for;
  MathML_tag_end(~F,"ul");
  MathML_tag_end(~F,"li");

  MathML_tag_begin(~F, "li");
  MathML_tag_1(~F, "B", "Lifting System:");
  MathML_tag_begin(~F,"math");
  print_lifting_system(~F, lf`LiftingSystem);
  MathML_tag_end(~F,"math");
  MathML_tag_end(~F, "li");

  MathML_tag_begin(~F, "li");
  MathML_tag_1(~F, "B", "Generic Trace:");
  MathMLPut(~F, replace_lt_and_gt(Sprint(lf`GenericTrace`Trace)));
  MathML_tag_end(~F, "li");

  MathML_tag_end(~F,"ul");
end intrinsic;


intrinsic HTML_FiberInfo(~F,lf::Rec,linkedfile::MonStgElt)
{ 
  prints in a html file called F the following informations
  of the fiber lf : dimension,degree and mutiplicity. A link is created 
  from the name of the fiber in the HTML file F to the HTML file
  linkedfile which contains the fiber written by the above fonction 
  FiberFileWrite. These files own to the directory of the current session
}
 
     
   MathML_tag_begin(~F,"ul");

   MathML_tag_begin(~F,"li");
   MathML_tag_1(~F, "B", "dimension = ");
   MathML_tag_begin(~F,"math");
   MathML(~F,RankLF(lf));
   MathML_tag_end(~F,"math");
   MathML_tag_end(~F,"li");

   MathML_tag_begin(~F,"li");
   MathML_tag_1(~F, "B", "degree = ");
   MathML_tag_begin(~F,"math");
   MathML(~F,DegreeLF(lf));
   MathML_tag_end(~F,"math");
   MathML_tag_end(~F,"li");

   MathML_tag_begin(~F,"li");
   if IsMultipleLF(lf) then 
      result:=1;
   else 
      result:=0;
   end if;

   if result eq 0 then
      MathML_tag_1(~F, "I", "without multiplicity");
   else 
      MathML_tag_1(~F, "I", "with multiplicity");
   end if;

   MathML_tag_end(~F,"li");
   MathML_tag_end(~F,"ul");

   MathML_a_begin (~F, linkedfile);
   MathML(~F," see the fiber"); 
   MathML_tag_end (~F, "a");
   MathML_tag_1(~F,"br","");

 
end intrinsic;
   

intrinsic FiberFileWrite(~F, filename::MonStgElt, lf::Rec)
{
 opens and writes in a HTML file called filename the fiber lf 
 using the function MML_PrintLF.
}
  MathML_open_page(~F, filename, "FIBER");
  MathML_tag_begin(~F,"center");
  MathML_tag_1(~F,"h1","Fiber " cat lf`Stamp);
  MathML_tag_end(~F,"center");
  MML_PrintLF(~F,lf);
  MathML_tag_1(~F,"br","");
  MathML_a_begin(~F, "index.html");
  MathML(~F, "Return to index page");
  MathML_tag_end(~F, "a");
  MathML_tag_1(~F,"br","");
  MathML_close_page(~F);
end intrinsic;  


/******************************************************************
			sequence of fibers
******************************************************************/


intrinsic MathMLLLF(~F,answer::SeqEnum)
{ 
}
  MathML_tag_begin(~F,"ul");
  for zz in answer do
    for z in zz do
      MathML_tag_begin(~F,"li");
      MathML_tag_1(~F, "i", "Component of ");
      MathML_tag_1(~F, "i", "dimension");
      MathML_tag_1(~F,"math",RankLF(z));
      MathML_tag_1(~F, "i", "and degree");
      MathML_tag_1(~F,"math",DegreeLF(z));
      filename:= MathML_new_filename(F);
      FiberFileWrite(~F,filename,z);
      MathML_a_begin (~F, filename);
      MathML(~F,z`Stamp); 
      MathML_tag_end (~F, "a");
      MathML_tag_end(~F,"li");
      FlushMathMLSession(~F);
    end for;
  end for;
  MathML_tag_end(~F,"ul");    
  FlushMathMLSession(~F);
end intrinsic;
   

