// # 1 "oneirredcomp.mtx"
// $Header$
// # 1 "header.h" 1
/*
///////////////////////////////////////////////////

   Kronecker Package version 0.166-9 for Magma

///////////////////////////////////////////////////

Date: sam jun  8 14:57:49 UTC 2002
Copyright (C) 1999--2002, G. Lecerf, Centre National de la Recherche Scientifique
Location: 
          Laboratoire de mathmatiques, LAMA - UMR 8100
          Universit de Versailles St-Quentin-en-Yvelines
          45 avenue des Etats-Unis - Btiment Fermat
          78035 Versailles, France
Url: http://kronecker.medicis.polytechnique.fr/
Bug report to: Gregoire.Lecerf@math.uvsq.fr

!!! WARNING, this package comes with NO WARRANTY !!!
*/

// # 3 "oneirredcomp.mtx" 2
// $Log$

import "intersect.mgm" : KroneckerIntersectResultant,SubstituteNewParametrizationInOldOne;
import "hensel_base.m": hensel_base__FromSeriesToRationalCoefficients, hensel_base__FromSeriesToRationalCoefficients_Pade, hensel_base__EvaluateAtOne, hensel_base__MultiplyByCommonDenominator, hensel_base__StopCriterion_Bound, hensel_base__StopCriterion_Integers, hensel_base__HeuristicCombineFactorized;// #import hensel_base.m



intrinsic OneIrreducibleComponent(equations,inequations) -> .
{
}
  s:=#equations;
  if s eq 0 then return([]); end if;
  R:=equations[1]`Parent;
  n:=Rank(R);
  F:=BaseRing(R);
F:=GF(NextPrime(125));
F;
//  ans:= WholeSpaceLF(R,F:GenericLinearChangeOfVariables:=false);
  ans:= WholeSpaceLF(R,F);

  for i:=0 to s-2 do
    D:=DegreeLF(ans);
    f:=equations[i+1];
    _:=Gradient(f);  // understand why necessary ?
    vprint NonUniversalVerbose,1: i,"equations solved";

    // Compute the degree of the intersection
    mp1:=ans`MagicPoint;
    mp1[n-i]+:=1;
    lc1:=ans;
    LiftCurveLF(~lc1,mp1,D+1);
    MakeKroneckerParametrizationLF(~lc1);
    CombineLF(~lc1:Parametrization:="Kronecker");
    hensel_base__FromSeriesToRationalCoefficients(~lc1);
    q:= KroneckerIntersectResultant(lc1,f);
    q:= q/LeadingCoefficient(q);
    delta:=Degree(q);
    vprint NonUniversalVerbose,1: "degree found for the intersection",delta;

    MP:=PolynomialAlgebra(F,2);
    
    Q:=[];
    for j:=1 to delta+1 do
      vprint NonUniversalVerbose,1: "interpolation point",j,"/",delta+1;
      mp:= ans`MagicPoint;
      mp[n-i]+:=1;
      mp[1]+:=j;
      tmp:=ans;
      LiftCurveLF(~tmp,mp,D+1);
      MakeKroneckerParametrizationLF(~tmp);
      CombineLF(~tmp:Parametrization:="Kronecker");
      hensel_base__FromSeriesToRationalCoefficients(~tmp);
      assert VerifyLF(tmp);
      q:=KroneckerIntersectResultant(tmp,f);
      Append(~Q, [Evaluate(q,l):l in [1..delta+1]]);
    end for;
    tmp:=[];
    for l:=1 to delta+1 do
      z:=Interpolation([F| F!(j*l) : j in [1..delta+1]], [ Q[j][l] : j in [1..delta+1]]);
      z:=&+ [MP | Coefficient(z,j)*(MP.1)^j : j in [0..delta]];
      Append(~tmp, z);
    end for;

    Q:=Interpolation( [F| F!l : l in [1..delta+1]],tmp,2);
    Q;
    vprint NonUniversalVerbose,1: "factorization";
    Q_factors:=Factorization(Q);
    Q_factors;
    for factor in Q_factors do
      vprint NonUniversalVerbose,2: "examining new factor";
      Q:=factor[1];
      UP<T>:=PolynomialAlgebra(F);
      Q:=Evaluate(Q,[0,T]);
      Q:= Q/LeadingCoefficient(Q);
      q:=lc1`MinimalPolynomial[1];
      p:=lc1`Denominator[1];
      w:=lc1`Parametrization[1];
      y0:=F!Evaluate(lc1`MagicPoint[#lc1`MagicPoint],F!0);
      newparametrizations:= SubstituteNewParametrizationInOldOne(lc1,f,q,p,w,Q,y0,true);
      if Type(newparametrizations) eq MonStgElt then
        lc:="INTERSECT_NOETHER";// >> TODO
        return lc;
      end if;
    
      // updating the fiber
      for i:=1 to #newparametrizations do
        param:=newparametrizations[i];
        loclc:=lc1;
        loclc`ResolutionField := F;
        loclc`MinimalPolynomial := param[1];
        if param[3] gt 1 then loclc`IsMultiple:=true; end if;
        loclc`Denominator := [UP| UP!1 : z in param[1]];
        loclc`Parametrization := param[2];
        loclc`PrimitiveElement := ParentBbpLF(loclc).RankLF(loclc);
        Append(~loclc`LiftingSystem,f);
        loclc`MagicPoint:= Prune([Rationals()| Integers()!Evaluate(x,F!0)
	  : x in loclc`MagicPoint]);
	  // TODO revoir le stamp
        loclc`Stamp cat:= "![" cat Sprint(f`Address) cat "]^[" cat Sprint(param[3]) cat "]";
        ans:=loclc;
        CleanLF(~ans,inequations);
        if not IsEmptyLF(ans) then break; end if;
      end for;
      if not IsEmptyLF(ans) then break; end if;
    end for;
    vprint NonUniversalVerbose,1: "checking resolution:",VerifyLF(ans);
  end for;

  // easy last step
  LiftLastFreeVariableLF(~ans);
  KroneckerIntersect(~ans,equations[s]);
  CleanLF(~ans,inequations);
  
  ChangeBackAlgebraicVariablesLF(~ans);
  ChangeBackFreeVariablesLF(~ans);
  MakeMonicLF(~ans);
  FindSmallNoetherPositionLF(~ans);
  MakeMonicLF(~ans);
  FindSmallPrimitiveElementLF(~ans);
  MakeMonicLF(~ans);
  FindSmallMagicPointLF(~ans);
  MakeMonicLF(~ans);


  return(ans);
end intrinsic;
