// # 1 "random.mtx"
// $Header$
// # 1 "header.h" 1
/*
///////////////////////////////////////////////////

   Kronecker Package version 0.166-9 for Magma

///////////////////////////////////////////////////

Date: sam jun  8 14:57:47 UTC 2002
Copyright (C) 1999--2002, G. Lecerf, Centre National de la Recherche Scientifique
Location: 
          Laboratoire de mathmatiques, LAMA - UMR 8100
          Universit de Versailles St-Quentin-en-Yvelines
          45 avenue des Etats-Unis - Btiment Fermat
          78035 Versailles, France
Url: http://kronecker.medicis.polytechnique.fr/
Bug report to: Gregoire.Lecerf@math.uvsq.fr

!!! WARNING, this package comes with NO WARRANTY !!!
*/

// # 3 "random.mtx" 2
// $Log$

/*
  This file is intented to contain the configuration of the random
  choices of the Kronecker package.
*/

random_RandomInvertibleMatrix:=function(K,n) 
//------------------------------------------
/*
  It returns an invertible matrix with coefficients in K.
*/
  I:=ScalarMatrix(n,K!1);
  M:=Matrix([ [K| Random(10^50) : i in [1..n]]: i in [1..n]]);
  while Determinant(M) eq 0 do M+:=I; end while;
  return(M);
end function;

random_RandomInvertibleUpperTriangularMatrix:=function(K,n) 
//---------------------------------------------------------
/*
  It returns an invertible matrix with coefficients in K.
*/
  I:=ScalarMatrix(n,K!1);
  M:=UpperTriangularMatrix(K,&cat[ [K| Random(10^50) : j in [i..n]]: i in [1..n]]);
  while Determinant(M) eq 0 do M+:=I; end while;
  return(M);
end function;

random_RandomVector:=function(K,n)
//--------------------------------
/*
  It returns a random vector with coefficients in K.
*/
  return Vector([K | Random(10^50) : i in [1..n]]);
end function;

random_RandomPrimeNumber:=function()
//----------------------------------
/*
  It returns a random prime number.
*/
  N:=5;
  N:=8;
  return(NextPrime(Random(10^N)+10^N));

end function;

random_RandomSequence:=function(K,n)
//----------------------------------
/*
  It returns a random sequence over K of size n.
*/

  return([K| Random(10^10)+10^50 : i in [1..n]]);

end function;

