// # 1 "subres.mtx"
// $Header$
// # 1 "header.h" 1
/*
///////////////////////////////////////////////////

   Kronecker Package version 0.166-9 for Magma

///////////////////////////////////////////////////

Date: sam jun  8 14:57:50 UTC 2002
Copyright (C) 1999--2002, G. Lecerf, Centre National de la Recherche Scientifique
Location: 
          Laboratoire de mathmatiques, LAMA - UMR 8100
          Universit de Versailles St-Quentin-en-Yvelines
          45 avenue des Etats-Unis - Btiment Fermat
          78035 Versailles, France
Url: http://kronecker.medicis.polytechnique.fr/
Bug report to: Gregoire.Lecerf@math.uvsq.fr

!!! WARNING, this package comes with NO WARRANTY !!!
*/

// # 3 "subres.mtx" 2
// $Log$

// # 1 "macros.h" 1
// $Header$
// $Log$


















declare verbose BbpVerbose,5;
GlobalBbpVerbose:=[0,0,0,0,0,5];
declare verbose FdaVerbose,5;
GlobalFdaVerboseVerbose:=[0,0,0,1,2,3];
declare verbose FiberVerbose,5;
GlobalFiberVerbose:=[0,1,2,3,4,5];
declare verbose GeometricSolveVerbose,5;
GlobalGeometricSolveVerbose:=[0,1,2,3,4,5];
declare verbose HenselVerbose,5;
GlobalHenselVerboseVerbose:=[0,1,2,3,3,4];
declare verbose IntersectionVerbose,5;
GlobalIntersectionVerbose:=[0,1,2,2,3,4];
declare verbose NonUniversalVerbose,5;
GlobalNonUniversalVerbose:=[0,1,2,3,4,5];
declare verbose AlgebraicApproximantVerbose,5;
GlobalAlgebraicApproximantVerbose:=[0,0,0,1,2,3,5];




















// MathML support

declare verbose KroneckerMathMLVerbose,5;









// # 6 "subres.mtx" 2

intrinsic SubResultant(p,q) ->.,.
{
 
    p, univariate polynomial.
    q, univariate polynomial.
 
 
    r,s, the resultant of p and q and the
    last subresultant up to the sign.
 
}
    // Bon, c'est pas tres clair ce qui se passe avec les cas
    // triviaux, faudra verifier ... >> TODO
    // NOTE : pour des raisons historiques, on calcule Sylvester-Habicht !

    UP:=Parent(p);
    F:=BaseRing(UP);

    u := p;
    du := Degree(u);
    v := q;
    dv := Degree(v);

    if du lt dv then
      r,s:=$$(v,u);
      return F!((-1)^(du*dv)*r),UP!((-1)^(du*dv)*s);
    end if;

    if v eq 0 then
      if du eq 1 then
        return UP!0,u;
      else return F!0,UP!0;
      end if; 
    end if;

    if du lt dv then
      r,s:=$$(v,u);
      return F!((-1)^(du*dv)*r),UP!((-1)^(du*dv)*s);
    end if;

    j:=  Max(Degree(u),Degree(v)+1);
    H:= [ UP!0 : i in [1..j+1]];
    h:= [ F!0 : i in [1..j+1]];
    H[j+1]:= u;
    h[j+1]:= F!1;
    H[j]:= v;
    delta:=function(n)
      t:= ((n*(n-1) div 2));
      return((-1)^t);
    end function;

    while j gt 1 do
      k:= Max(0,Degree(H[j]));
      if k lt j-1 then 
        temp1:= (h[j+1])^(j-k-1);
        temp2:= delta(j-k)*Coefficient(H[j],k)^(j-1-k)*H[j]/temp1;
        H[k+1]:= temp2;
      end if;
      for l:=k+1 to j-2 do H[l+1]:= 0; end for;
      if k gt 0 then
        temp1:= (h[j+1])^(j-k+1);
        temp2:= delta(j-k+2)*PseudoRemainder(H[j+1],H[j])/temp1;
        H[k]:= temp2;
      end if;
      h[k+1]:= Coefficient(H[k+1],k);
      j:= k;
    end while;
    assert Degree(H[1]) le 0;
    return Coefficient(H[1],0),H[2];

end intrinsic;

