// TODO : HasSignature("Sign",[FldRatElt]);

/************************************************************************
		Definitions
************************************************************************/
















declare verbose GeometricSolveVerbose,5;
declare verbose KroneckerHensel,5;
declare verbose IntersectionVerbose,5;
declare verbose KroneckerMathMLVerbose,5;








/*
    Sprint(c) gt 7


      nbterm gt 3

      n gt 3

     n gt 6
*/
 


























//#define DEBUG 

// TODO << put all the attributes
intrinsic MathMLAttributes() -> .
{
  Returns the recformat used to store MathML attributes.
}
  return  recformat< mathcolor, border, bgcolor, mathsize, displaystyle, href, name, open, close, color, columnalign>;
end intrinsic;

intrinsic MathMLPut(~F,x)
{
}
  Put(F`Pipe,x);
end intrinsic;

/*************************************************************************
                          Opening and closing sessions
*************************************************************************/

intrinsic OpenMathMLSession() -> .
{
  Return a pipe where all MathML ouput needs to be written
}




  F:=POpen("mml4mgm","w");

  R:=recformat<Pipe, Files>; 
  return rec<R| Pipe:=F, Files:=[]>;

end intrinsic;

intrinsic CloseMathMLSession(~F)
{
  Close the pipe F used for MathML output
}
  Flush(F`Pipe);
end intrinsic;

intrinsic FlushMathMLSession(~F)
{
  Flush the pipe F used for MathML output
}
  Flush(F`Pipe);
end intrinsic;


/******************************************************************************
                           Tag Primitives
******************************************************************************/

intrinsic MathML_attributes(~F,attributes)
{
  Prints the attributes
}
  ans:="";
  for n in Names(attributes) do
    	if assigned attributes``n then
    		ans:= ans cat " " cat n cat "=\"" cat attributes``n  cat "\"";	
    	end if;
  end for;
  MathMLPut(~F,ans);
end intrinsic;

intrinsic MathML_tag_begin(~F, tag::MonStgElt : attributes:=rec<MathMLAttributes()|>)
{
  Print begin tag together with its attributes
}
  MathMLPut(~F,"\n<" cat tag);
  if assigned attributes then
  	MathML_attributes(~F,attributes);
  end if;
  MathMLPut(~F,">\n");
end intrinsic;

intrinsic MathML_tag_end(~F, tag::MonStgElt)
{
 Print end tag
}                        
  ans:= "</" cat Sprint(tag) cat ">\n";
  MathMLPut(~F,ans);
  
end intrinsic;               

intrinsic MathML_tag_1(~F, tag::MonStgElt, x: attributes:= rec<MathMLAttributes()| >)
{
  Enclose x in the tag
}
  MathML_tag_begin(~F,tag :attributes:=attributes);
  MathMLPut(~F,Sprint(x));
  MathML_tag_end(~F,tag);
end intrinsic;               

intrinsic MathML_tag_2 (~F, tag::MonStgElt,x,y :attributes:=rec<MathMLAttributes()|>, xattributes:=rec<MathMLAttributes()|>, yattributes:=rec<MathMLAttributes()|>)  
{
  Enclose x and y in a binary tag like msub
}
  MathML_tag_begin(~F,tag: attributes:=attributes);
  MathML(~F,x :attributes:=xattributes);
  MathML(~F,y :attributes:=yattributes);
  MathML_tag_end(~F,tag);
end intrinsic;

intrinsic MathML_merge_attributes(first_attributes , more_attributes ) -> .
{
 Overwrite and add more_attributes to first_attributes
}
  for n in Names(more_attributes) do
    	if assigned more_attributes``n then
         	first_attributes``n:=more_attributes``n;
        end if;
  end for;
  return first_attributes;
end intrinsic;

/******************************************************************************
                              usefull functions
******************************************************************************/

intrinsic MathML_new_filename(F) -> MonStgElt
{
}
  x:=1000;
  while true do
    for i:=1 to x div 2 do
      f:=Sprint(Random(x)) cat ".html";
      if not (f in F`Files) then
        return f;
      end if;
    end for;
  x*:=2;
  end while;
end intrinsic;

intrinsic MathML_open_page(~F, filename::MonStgElt, title::MonStgElt :body_parameter:= rec<MathMLAttributes()|>)
{
  opens a titled HTML page with optional attributes like background color
}
  MathML_file_begin(~F,filename);
  MathML_tag_begin(~F,"html");
  MathML_tag_begin(~F,"head");
  MathML_tag_1(~F, "title",title);
  MathML_tag_end(~F,"head");
  MathML_body_begin(~F : attributes:= body_parameter);
  Append(~F`Files,filename);
end intrinsic;

intrinsic MathML_close_page (~F)
{ 
 closes a HTML page.
}
  MathML_tag_end(~F, "body");
  MathML_tag_end(~F, "html");
  MathML_tag_end(~F, "file");
 
end intrinsic;  

intrinsic MathML_body_begin(~F :attributes:=rec< MathMLAttributes() |> )
{
}
  attrib:=rec< MathMLAttributes() | bgcolor:="white">;
  if assigned attributes then  
  	attrib:=MathML_merge_attributes(attrib, attributes);
  end if;
  MathML_tag_begin(~F,"body" :attributes:=attrib);
end intrinsic;

intrinsic MathML_file_begin(~F, name::MonStgElt :attributes:=rec< MathMLAttributes() |>)
{
 new tag for the python parser. Shows the beginning of a new file.
}
  attrib:=rec< MathMLAttributes()| name:=name>;
  if assigned attributes then  
  	attrib:=MathML_merge_attributes(attrib, attributes);
  end if; 
  MathML_tag_begin(~F,"file" :attributes:=attrib);

end intrinsic;

intrinsic MathML_a_begin(~F, href::MonStgElt :attributes:=rec< MathMLAttributes() |>)
{
 puts a link with optional attributes.
}
  attrib:=rec< MathMLAttributes()| href:=href>;
  if assigned attributes then  
  	attrib:=MathML_merge_attributes(attrib, attributes);
  end if; 
  MathML_tag_begin(~F,"a" :attributes:=attrib);

end intrinsic;

intrinsic MathML_dots_link(~F, name::MonStgElt :attributes:=rec< MathMLAttributes() |>)
{
 creates links inside mathml expression attached to 3 horizontal points.
}
     attrib:=rec< MathMLAttributes()| href:=name , mathcolor:="blue", mathsize:="big" >;
     if assigned attributes then  
  	attrib:=MathML_merge_attributes(attrib, attributes);
     end if;  
     MathML_tag_1(~F,"mo", "..." : attributes:=attrib); 
end intrinsic;

intrinsic MathML_mfenced_begin(~F, open_fence:: MonStgElt, close_fence:: MonStgElt :attributes:=rec< MathMLAttributes() |>)
{
 opens MathML fences for matrix, vector, sequences, system with optional
 attributes.
}
  attrib:=rec< MathMLAttributes()| open:=open_fence , close:= close_fence>;
  if assigned attributes then  
  	attrib:=MathML_merge_attributes(attrib, attributes);
  end if; 
  MathML_tag_begin(~F,"mfenced" :attributes:=attrib);    
end intrinsic;

/************************************************************************
                        Magma's objects
************************************************************************/

intrinsic MathML(~F, x::ModFldElt :attributes:=rec< MathMLAttributes() |>)
{
}
  MathML_tag_1(~F,"mn",x :attributes:=attributes);
end intrinsic;

intrinsic MathML(~F, x::RngIntElt : max:=5, attributes:=rec< MathMLAttributes() |>)
{
}
  s:=Sprint(x);
  zoom:=false;
  MathML_tag_begin(~F,"mn":attributes:=attributes);
  for i:=1 to #s do
    if i gt max and i le #s-max and max gt 0 then
      if zoom then continue; end if;
      f:=MathML_new_filename(F);
      MathML_open_page(~F, f, "Zoom in");
      MathML_tag_begin(~F,"math");
      MathML(~F, x: max:=-1, attributes:=attributes);
      MathML_tag_end(~F,"math");
      MathML_close_page(~F);
      MathML_dots_link(~F,f: attributes:=attributes);
      zoom:=true;
      continue;
    end if;
    Put(F`Pipe,s[i]);
  end for;
  MathML_tag_end(~F,"mn");
end intrinsic;

intrinsic MathML(~F,x::RngIntResElt :attributes:=rec< MathMLAttributes() |>)
{
}
  MathML_tag_1(~F,"mn",x :attributes:=attributes);
end intrinsic;

intrinsic MathML(~F,x::FldFinElt :attributes:=rec< MathMLAttributes() |>)
{
}
  MathML_tag_1(~F,"mn",x :attributes:=attributes);
end intrinsic;

intrinsic MathML(~F,x::FldRatElt :attributes:=rec< MathMLAttributes() |>)
{
}
   den:=Denominator(x);
   num:=Numerator(x);
   if IsOne(den) then
     MathML(~F, num:attributes:=attributes);
   else
     MathML_tag_2(~F, "mfrac", num, den:attributes:=attributes);
   end if;
end intrinsic;

intrinsic MathML(~F,x::MonStgElt :attributes:=rec< MathMLAttributes()|> )
{
}
   MathML_tag_1(~F, "mi",x :attributes:=attributes); 
end intrinsic;

intrinsic MathML(~F, x::SeqEnum: max:=3, attributes:=rec< MathMLAttributes()|>)
{
}
  MathML_mfenced_begin(~F, "[", "]" :attributes:=attributes); 
  MathML_tag_begin (~F,"mtable");
  MathML_tag_begin(~F,"mtr");
  first:=true;
  if max gt 0 then zoom:=false; else zoom:=true; end if;
  for i:=1 to #x do
    z:=x[i];
    if i gt max and i le #x-max and max gt 0 then
      if zoom then continue; end if;
      f:=MathML_new_filename(F);
      MathML_open_page(~F, f, "Zoom in");
      MathML_tag_begin(~F,"math");
      MathML(~F, x: max:=-1, attributes:=attributes);
      MathML_tag_end(~F,"math");
      MathML_close_page(~F);
      MathML_tag_begin(~F,"mtd");
      MathML_tag_1(~F, "mo", ",");
      MathML_tag_end(~F,"mtd");
      MathML_dots_link(~F,f: attributes:=attributes);
      zoom:=true;
      continue;
    end if;
    if not first then
      MathML_tag_begin(~F,"mtd");
      MathML_tag_1(~F, "mo", ",");
      MathML_tag_end(~F,"mtd");
    end if;
    MathML_tag_begin(~F,"mtd");
    MathML(~F,z :attributes:=attributes);
    MathML_tag_end(~F,"mtd");
    first:=false;
  end for;
  MathML_tag_end(~F,"mtr");
  MathML_tag_end(~F,"mtable");
  MathML_tag_end(~F,"mfenced");
end intrinsic;

intrinsic MathML(~F, x::Tup: max:=3, attributes:=rec< MathMLAttributes()|>)
{
}
  MathML_mfenced_begin(~F, "&lt;", "&gt;" :attributes:=attributes); 
  MathML_tag_begin (~F,"mtable");
  MathML_tag_begin(~F,"mtr");
  first:=true;
  if max gt 0 then zoom:=false; else zoom:=true; end if;
  for i:=1 to #x do
    z:=x[i];
    if i gt max and i le #x-max and max gt 0 then
      if zoom then continue; end if;
      f:=MathML_new_filename(F);
      MathML_open_page(~F, f, "Zoom in");
      MathML_tag_begin(~F,"math");
      MathML(~F, x: max:=-1, attributes:=attributes);
      MathML_tag_end(~F,"math");
      MathML_close_page(~F);
      MathML_tag_begin(~F,"mtd");
      MathML_tag_1(~F, "mo", ",");
      MathML_tag_end(~F,"mtd");
      MathML_dots_link(~F,f: attributes:=attributes);
      zoom:=true;
      continue;
    end if;
    if not first then
      MathML_tag_begin(~F,"mtd");
      MathML_tag_1(~F, "mo", ",");
      MathML_tag_end(~F,"mtd");
    end if;
    MathML_tag_begin(~F,"mtd");
    MathML(~F,z :attributes:=attributes);
    MathML_tag_end(~F,"mtd");
    first:=false;
  end for;
  MathML_tag_end(~F,"mtr");
  MathML_tag_end(~F,"mtable");
  MathML_tag_end(~F,"mfenced");
end intrinsic;

has_multiple_terms:=function(c)
  if HasSignature("Denominator",[Type(c)]) then
    if Denominator(c) eq 1 then
      return $$(Numerator(c));
    else
      return false;
    end if;
  end if;
  if Type(c) eq RngMPolElt then
    if #Terms(c) gt 1 then return true; else return false; end if;
  end if;
  if HasSignature("Eltseq",[Type(c)]) then
    if #Eltseq(c) gt 1 then return true; else return false; end if;
  end if;
  return true;
end function;

intrinsic MathML(~F, x::RngUPolElt: max:=3, attributes:=rec< MathMLAttributes()|>)
{
}
  UP:=Parent(x);
  v:=Sprint(UP.1);
  deg:=Degree(x);
  R:=BaseRing(UP);
  
  if max gt 0 then zoom:=false; else zoom:=true; end if;

  a:=deg; i:=1;
  while a ge 0 and i le max do
    if Coefficient(x,a) ne 0 then i+:=1; end if;
    a-:=1;
  end while;
  
  b:=0; i:=1;
  while b le deg and i le max do
    if Coefficient(x,b) ne 0 then i+:=1; end if;
    b+:=1;
  end while;
  
  for i:=Max(deg,0) to 0 by -1 do
    c:=Coefficient(x,i);
    if c eq 0 and deg gt 0 then continue; end if;
    op:="+";
//    if HasSignature("Sign",[Type(c)]) then
    if Type(c) in [FldRatElt, RngIntElt] then    
      if Sign(c) eq -1 then op:="-"; c:= -c; end if;
    end if;
    if c eq 0 then op:=""; end if;
    if i ge b and i le a and max gt 0 then
      if not zoom then
        f:=MathML_new_filename(F);
        MathML_open_page(~F, f, "Zoom in");
        MathML_tag_begin(~F,"math");
        MathML(~F, x: max:=-1, attributes:=attributes);
        MathML_tag_end(~F,"math");
        MathML_close_page(~F);
        MathML_tag_1(~F, "mo", op);
        MathML_dots_link(~F,f: attributes:=attributes);
        zoom:=true;
      end if;
      continue;
    end if;
    if i ne deg or op eq "-" then MathML_tag_1(~F, "mo", op); end if;
    if c ne 1 or (c eq 1 and i eq 0) then
       par:= has_multiple_terms(c);
       if par then MathML_tag_1(~F,"mi","("); end if;
       MathML(~F,c);
       if par then MathML_tag_1(~F,"mi",")"); end if;
    end if;
    if i eq 0 then continue; end if;
//    if c ne 1 then MathML_tag_1(~F,"mn", "&InvisibleTimes;"); end if;
    if i eq 1 then
      MathML_tag_1(~F,"mi", v);
      continue;
    end if;
    MathML_tag_2(~F, "msup", v,i );
  end for;
end intrinsic;

intrinsic MathML(~F, x::RngMPolElt: max:=3, attributes:=rec< MathMLAttributes()|>)
{
}
  MP:=Parent(x);
  n:=Rank(MP);
  terms:=Terms(x);

  if max gt 0 then zoom:=false; else zoom:=true; end if;
  
  if #terms eq 0 then MathML(~F,BaseRing(MP)!0); return; end if;
  if x eq 1 then MathML(~F,BaseRing(MP)!1); return; end if;
  
  for i:=#terms to 1 by -1 do
    t:=terms[i];

    if i gt max and i le #terms-max and max gt 0 then
      if not zoom then
        f:=MathML_new_filename(F);
        MathML_open_page(~F, f, "Zoom in");
        MathML_tag_begin(~F,"math");
        MathML(~F, x: max:=-1, attributes:=attributes);
        MathML_tag_end(~F,"math");
        MathML_close_page(~F);
        MathML_tag_1(~F, "mo", "+");
        MathML_dots_link(~F,f: attributes:=attributes);
        zoom:=true;
      end if;
      continue;
    end if;

    c:=LeadingCoefficient(t);
    d:=TotalDegree(t);
    e:=Exponents(t);
    op:="+";
//    if HasSignature("Sign",[Type(c)]) then
    if Type(c) in [FldRatElt, RngIntElt] then
      if Sign(c) eq -1 then op:="-"; c:= -c; end if;
    end if;
    if c eq 0 then op:=""; end if;
    if i ne #terms or op eq "-" then MathML_tag_1(~F, "mo", op); end if;
    if c ne 1 or (c eq 1 and d eq 0) then
      par:= has_multiple_terms(c);
      if par then MathML_tag_1(~F,"mo","("); end if;
      MathML(~F,c);
      if par then MathML_tag_1(~F,"mo",")"); end if;
    end if;
    if d eq 0 then continue; end if;
    for j:=1 to n do
      if e[j] eq 0 then continue; end if;
//      if c ne 1 then MathML_tag_1(~F,"mn", "&InvisibleTimes;"); end if;
      if e[j] eq 1 then
        MathML_tag_1(~F,"mi", Sprint(MP.j));
        continue;
      end if;
      MathML_tag_2(~F, "msup", Sprint(MP.j),e[j] );
    end for;
  end for;
end intrinsic;

intrinsic MathML(~F, x::FldFunRatMElt: max:=3, attributes:=rec< MathMLAttributes()|>)
{
}
   den:=Denominator(x);
   num:=Numerator(x);
   if IsOne(den) then
     MathML(~F, num:max:=max, attributes:=attributes);
   else
     MathML_tag_2(~F, "mfrac", num, den: max:=max, attributes:=attributes);
   end if;
end intrinsic;

/*********************************************************************
		            vectors
*********************************************************************/

intrinsic MathML(~F, x::ModTupRngElt)
{ 
}
 MathML_tag_begin(~F,"mrow");
 MathML_mfenced_begin(~F,"(",")"); 
 MathML_tag_begin(~F,"mtable");
 for i:=1 to NumberOfColumns(x) do
     MathML_tag_begin(~F,"mtr");
     MathML_tag_begin(~F,"mtd");
     MathML(~F, x[i]);
     MathML_tag_end(~F,"mtd");
     MathML_tag_end(~F,"mtr"); 
 end for;
 MathML_tag_end(~F,"mtable");
 MathML_tag_end(~F,"mfenced");   
 MathML_tag_end(~F,"mrow");
end intrinsic;    

/*********************************************************************
				matrix
*********************************************************************/

intrinsic MathML(~F, a::Mtrx :attributes:=rec< MathMLAttributes()|>)
{
}
  MathML_mfenced_begin(~F,"(",")"); 
  MathML_tag_begin(~F,"mtable");
  for i:=1 to NumberOfRows(a)  by 1 do
    MathML_tag_begin(~F,"mtr");
    for j:=1 to NumberOfColumns(a) by 1 do
      MathML_tag_begin(~F,"mtd");
      MathML(~F,a[i,j]);
      MathML_tag_end(~F,"mtd");
    end for;
    MathML_tag_end(~F,"mtr");
  end for;
  MathML_tag_end (~F,"mtable");
  MathML_tag_end (~F,"mfenced");  
end intrinsic;

        
